/*
	save ip to file
*/

#include <stdio.h>
#include <unistd.h>
#include <string.h> /* for strncpy */

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <arpa/inet.h>

int main()
{
	char *data;
	char *p;
	short len;
	int result = -1;
	int temp = 0;

	char ip1[20];
	char ipsvr1[20];
	char ipsvr2[20];
	char port1[10];
	char portsvr1[10];
	char portsvr2[10];
	//char ip2[20];
	char tempIp[20];
	char dataTemp[100];
	memset(ip1, 0x0, sizeof(ip1));
	//memset(ip2, 0x0, sizeof(ip2));
	memset(tempIp, 0x0, sizeof(tempIp));
	memset(dataTemp, 0x0, sizeof(dataTemp));

	printf("Content-Type: text/html\n\n");

	data = (char *)getenv("QUERY_STRING");
	if(data == NULL)
	{
		printf("fail");
	}
	else
	{
		sscanf(data, "type=%1s", dataTemp);

		if(dataTemp[0] == 'I')
		{
			p = strtok(data, "&=");
			while(p != NULL)
			{
				if(0 == strcmp(p, "p1"))
				{
					p = strtok(NULL, "&=");
					sprintf(ip1, "%s", p);
				}
				else if(0 == strcmp(p, "p2"))
				{
					p = strtok(NULL, "&=");
					sprintf(port1, "%s", p);
				}
				else if(0 == strcmp(p, "p3"))
				{
					p = strtok(NULL, "&=");
					sprintf(ipsvr1, "%s", p);
				}
				else if(0 == strcmp(p, "p4"))
				{
					p = strtok(NULL, "&=");
					sprintf(portsvr1, "%s", p);
				}
				else if(0 == strcmp(p, "p5"))
				{
					p = strtok(NULL, "&=");
					sprintf(ipsvr2, "%s", p);
				}
				else if(0 == strcmp(p, "p6"))
				{
					p = strtok(NULL, "&=");
					sprintf(portsvr2, "%s", p);
				}
				/*else if(0 == strcmp(p, "p2"))
				{
					p = strtok(NULL, "&=");
					sprintf(ip2, "%s", p);
				}*/
				p = strtok(NULL, "&=");
			}
		}

		//check ip
		sprintf(tempIp, "%s", ip1);
		p = strtok(tempIp, ".");

		while(p != NULL)
		{
			len = strlen(p);
			if(len > 3 || len <= 0)
			{
				printf("-1");
				return -1;
			}

			if(p[0])
			{
				if(p[0] == 48)
				{
					printf("-1");
					return -1;
				}
				if(p[0] <= 48 || p[0] > 57)
				{
					printf("-1");
					return -1;
				}
			}

			if(p[1])
			{
				if(p[1] < 48 || p[1] > 57)
				{
					printf("-1");
					return -1;
				}
			}

			if(p[2] && len == 3)
			{
				if(p[2] < 48 || p[2] > 57)
				{
					printf("-1");
					return -1;
				}
			}

			p = strtok(NULL, ".");
		}

		sprintf(tempIp, "%s", ipsvr1);
		p = strtok(tempIp, ".");

		while(p != NULL)
		{
			len = strlen(p);
			if(len > 3 || len <= 0)
			{
				printf("-2");
				return -1;
			}

			if(p[0])
			{
				if(p[0] == 48)
				{
					printf("-2");
					return -1;
				}
				if(p[0] <= 48 || p[0] > 57)
				{
					printf("-2");
					return -1;
				}
			}

			if(p[1])
			{
				if(p[1] < 48 || p[1] > 57)
				{
					printf("-2");
					return -1;
				}
			}

			if(p[2] && len == 3)
			{
				if(p[2] < 48 || p[2] > 57)
				{
					printf("-2");
					return -1;
				}
			}

			p = strtok(NULL, ".");
		}

		sprintf(tempIp, "%s", ipsvr2);
		p = strtok(tempIp, ".");

		while(p != NULL)
		{
			len = strlen(p);
			if(len > 3 || len <= 0)
			{
				printf("-3");
				return -1;
			}

			if(p[0])
			{
				if(p[0] == 48)
				{
					printf("-3");
					return -1;
				}
				if(p[0] <= 48 || p[0] > 57)
				{
					printf("-3");
					return -1;
				}
			}

			if(p[1])
			{
				if(p[1] < 48 || p[1] > 57)
				{
					printf("-3");
					return -1;
				}
			}

			if(p[2] && len == 3)
			{
				if(p[2] < 48 || p[2] > 57)
				{
					printf("-3");
					return -1;
				}
			}

			p = strtok(NULL, ".");
		}

		//check port
		temp = atoi(port1);
		if(temp < 100 || temp > 50000)
		{
			printf("-4");
			return -1;
		}

		temp = atoi(portsvr1);
		if(temp < 100 || temp > 50000)
		{
			printf("-5");
			return -1;
		}

		temp = atoi(portsvr2);
		if(temp < 100 || temp > 50000)
		{
			printf("-6");
			return -1;
		}

		FILE *fp;
		FILE *fp1;
		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_ip.txt", "w")) == NULL)
		{
			printf("-1");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&ip1, sizeof(ip1), 1, fp) != 1)
			{
				printf("-1");//write fail
				fclose(fp);
				return -1;
			}
			else
			{
				result = 1;
			}
		}
		fclose(fp);

		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_port.txt", "w")) == NULL)
		{
			printf("-4");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&port1, sizeof(port1), 1, fp) != 1)
			{
				printf("-4");//write fail
				fclose(fp);
				return -1;
			}
			else
			{
				result = 1;
			}
		}
		fclose(fp);

		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_serverA.txt", "w")) == NULL)
		{
			printf("-2");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&ipsvr1, sizeof(ipsvr1), 1, fp) != 1)
			{
				fclose(fp);
				printf("-2");//write fail
				return -1;
			}
			else
			{
				result = 1;
			}
		}
		fclose(fp);

		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_serverB.txt", "w")) == NULL)
		{
			printf("-3");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&ipsvr2, sizeof(ipsvr2), 1, fp) != 1)
			{
				fclose(fp);
				printf("-3");//write fail
				return -1;
			}
			else
			{
				result = 1;
			}
		}
		fclose(fp);

		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_svr_portA.txt", "w")) == NULL)
		{
			printf("-5");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&portsvr1, sizeof(portsvr1), 1, fp) != 1)
			{
				fclose(fp);
				printf("-5");//write fail
				return -1;
			}
			else
			{
				result = 1;
			}
		}
		fclose(fp);

		if((fp = fopen("/home/flexyard/flexyard/sysconfig/config_svr_portB.txt", "w")) == NULL)
		{
			printf("-6");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&portsvr2, sizeof(portsvr2), 1, fp) != 1)
			{
				fclose(fp);
				printf("-6");//write fail
				return -1;
			}
			else
			{
				result = 1;
			}
		}
		fclose(fp);

		/*if((fp1 = fopen("/home/flexyard/flexyard/sysconfig/config_ip2.txt", "w")) == NULL)
		{
			printf("-1");//open fail
			return -1;
		}
		else
		{
			if(fwrite(&ip2, sizeof(ip2), 1, fp1) != 1)
			{
				//printf("-2");//write fail
				result = -2;
			}
			else
			{
				//printf("1");//success
				result = 1;
			}
		}
		fclose(fp1);*/
	}

	//printf("ip1=%s", ip1);
	printf("%d", result);

	return 0;
}
