/*
	Special Function Structure
*/

#ifndef DEF_SPEC_FUNCTION_DATA__
#define DEF_SPEC_FUNCTION_DATA__

typedef struct SpecFunc
{
	char salone;		//Stand-alone switch. (enable, disable). If enable, does not need run tcp program.
	char swstatus;		//Switch status.(Single switch, crossover A, crossover B)
	char cpd;		//crossover presence detection(switch a, switch b, both)
	char aureturn;		//Auto return function.(enable, disable)
	double bcaution;	//Caution battery level.(voltages)
	double bdisable;	//Disable battery level.(voltages)
}SPECT_FUNCTION_DATA;
#endif

